// winMsgPInst.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "winMsgPInst.h"
#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name
char szFileName[MAX_PATH] = "";					// the name of the plugin to install
char PluginsDir[MAX_PATH] = "";					// Plugins directory (from the registry)
char DllName[MAX_PATH] = "";					// Name of the dll only
char dest[MAX_PATH] = "";						// Destination file
char szFile[MAX_PATH];									// file from EDIT

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	MainDlg(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_WINMSGPINST, szWindowClass, MAX_LOADSTRING);
	//MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_WINMSGPINST);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), NULL, (DLGPROC)MainDlg);
   if (!hWnd)
   {
      return FALSE;
   }
   return TRUE;
}


// Message handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}

LRESULT CALLBACK MainDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		HKEY hKey;
		LONG lResult;
		lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Software\\Patchou\\MsgPlus2\\", 0, KEY_ALL_ACCESS, &hKey);
		if (lResult != ERROR_SUCCESS)
		{
			MessageBox(hDlg, "You do not have Messenger Plus! installed on your system, or your version is too old to support this.", "winMsgPInst", MB_OK | MB_ICONINFORMATION);
			PostQuitMessage(0);
		}
		DWORD PDtype, PDsize;
		PDsize = MAX_PATH;
		lResult = RegQueryValueEx(hKey, _T("PluginDir"), 0, &PDtype, (LPBYTE)&PluginsDir, &PDsize);
		if (lResult != ERROR_SUCCESS)
		{
			MessageBox(hDlg, "Your version of Messenger Plus! is too old to support plugins. Please upgrade your Messenger Plus! (http://www.msgplus.net/) if you want to install plugins.", "winMsgPInst", MB_OK | MB_ICONINFORMATION);
			PostQuitMessage(0);
		}
		return TRUE;
	case WM_CLOSE:
		PostQuitMessage(0);
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDCANCEL:
			EndDialog(hDlg, wParam);
			PostQuitMessage(0);
			break;
		case IDOK:
			GetDlgItemText(hDlg, IDC_FILE, (char *)szFile, MAX_PATH);
			if (!stricmp(szFileName, ""))
			{
				strcpy(szFileName, szFile);
			}

			if(!stricmp(szFileName, ""))
			{
				MessageBox(hDlg, "Please, select a file first.", "winMsgPInst", MB_OK | MB_ICONINFORMATION);
				break;
			}

			//First, let's inform MsgPlus! that we want to upgrade a plugin
			UINT nMsg;
			nMsg = RegisterWindowMessage("MessengerPlus_PluginChange");
			if (!PostMessage(HWND_BROADCAST, nMsg, 0, 0))
				MessageBox(NULL, "Sending message failed", "grrr...", MB_OK);
			//FCopy(src, dest)
			size_t j;
			j = 0;
			for (size_t i = 0; i<=strlen(szFileName); i++)
			{
				if (szFileName[i] == 92)
					j = i;
			}

			strcpy (DllName, "");
			strcat(DllName, szFileName+j+1);

			strcpy(dest, PluginsDir);
			strcat(dest, "\\");
			strcat(dest, DllName);
			DeleteFile(dest);
			if (!CopyFile(szFileName, dest, FALSE))
			{
				DWORD dw = GetLastError();
				LPVOID lpMsgBuf;
				FormatMessage( 
					FORMAT_MESSAGE_ALLOCATE_BUFFER | 
					FORMAT_MESSAGE_FROM_SYSTEM | 
					FORMAT_MESSAGE_IGNORE_INSERTS,
					NULL,
					dw,
					MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
					(LPTSTR) &lpMsgBuf,
					0,
					NULL );
				char message[MAX_PATH] = "";
				strcpy(message, "The following error has occured:\n");
				strcat(message, (char *)lpMsgBuf);
				MessageBox(hDlg, message, "winMsgPInst", MB_OK | MB_ICONERROR);
			}
			else
			{
				MessageBox(hDlg, "Plugin was installed succesfully!", "winMsgPInst", MB_OK | MB_ICONINFORMATION);
			}
			strcpy(szFile, "");
			strcpy(szFileName, "");
			strcpy(DllName, "");
			strcpy(dest, "");
			break;
		case IDC_BROWSE:
			OPENFILENAME ofn;
			ZeroMemory(&ofn, sizeof(ofn));
			ofn.lStructSize = sizeof(ofn); // SEE NOTE BELOW
			ofn.hwndOwner = hDlg;
			ofn.lpstrFilter = "MsgPlus! Plugins (*.dll)\0*.dll\0";
			ofn.lpstrFile = szFileName;
			ofn.nMaxFile = MAX_PATH;
			ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
			ofn.lpstrDefExt = "dll";
			if(GetOpenFileName(&ofn))
			{
				// Do something usefull with the filename stored in szFileName
				SetDlgItemText(hDlg, IDC_FILE, (char *)szFileName);
			}
			break;
		case IDC_ABOUT:
			if (!DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hDlg, (DLGPROC)About))
				MessageBox(hDlg, "About dialog creation failed!", "ERROR!", MB_OK | MB_ICONEXCLAMATION);
			break;
		}
		break;
	}
	return FALSE;
}
